##// END OF EJS Templates
Merge pull request #105 from g-vidal/drtyhlpr-master...
drtyhlpr -
r209:229e4ac6545e Fusion
parent child
Show More
@@ -1,183 +1,183
1 1 #
2 2 # Build and Setup RPi2/3 Kernel
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Fetch and build latest raspberry kernel
9 9 if [ "$BUILD_KERNEL" = true ] ; then
10 10 # Setup source directory
11 11 mkdir -p "${R}/usr/src/linux"
12 12
13 13 # Copy existing kernel sources into chroot directory
14 14 if [ -n "$KERNELSRC_DIR" ] && [ -d "$KERNELSRC_DIR" ] ; then
15 15 # Copy kernel sources
16 cp -r "${KERNELSRC_DIR}/*" "${R}/usr/src/linux"
16 cp -r "${KERNELSRC_DIR}/"* "${R}/usr/src/linux"
17 17
18 18 # Clean the kernel sources
19 19 if [ "$KERNELSRC_CLEAN" = true ] && [ "$KERNELSRC_PREBUILT" = false ] ; then
20 20 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" mrproper
21 21 fi
22 22 else # KERNELSRC_DIR=""
23 23 # Create temporary directory for kernel sources
24 24 temp_dir=$(as_nobody mktemp -d)
25 25
26 26 # Fetch current RPi2/3 kernel sources
27 27 if [ -z "${KERNEL_BRANCH}" ] ; then
28 as_nobody -u nobody git -C "${temp_dir}" clone --depth=1 "${KERNEL_URL}" linux
28 as_nobody git -C "${temp_dir}" clone --depth=1 "${KERNEL_URL}" linux
29 29 else
30 as_nobody -u nobody git -C "${temp_dir}" clone --depth=1 --branch "${KERNEL_BRANCH}" "${KERNEL_URL}" linux
31 fi
30 as_nobody git -C "${temp_dir}" clone --depth=1 --branch "${KERNEL_BRANCH}" "${KERNEL_URL}" linux
31 fi
32 32
33 33 # Copy downloaded kernel sources
34 mv "${temp_dir}/linux/*" "${R}/usr/src/linux/"
34 cp -r "${temp_dir}/linux/"* "${R}/usr/src/linux/"
35 35
36 36 # Remove temporary directory for kernel sources
37 37 rm -fr "${temp_dir}"
38 38
39 39 # Set permissions of the kernel sources
40 40 chown -R root:root "${R}/usr/src"
41 41 fi
42 42
43 43 # Calculate optimal number of kernel building threads
44 44 if [ "$KERNEL_THREADS" = "1" ] && [ -r /proc/cpuinfo ] ; then
45 45 KERNEL_THREADS=$(grep -c processor /proc/cpuinfo)
46 46 fi
47 47
48 48 # Configure and build kernel
49 49 if [ "$KERNELSRC_PREBUILT" = false ] ; then
50 50 # Remove device, network and filesystem drivers from kernel configuration
51 51 if [ "$KERNEL_REDUCE" = true ] ; then
52 52 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" "${KERNEL_DEFCONFIG}"
53 53 sed -i\
54 54 -e "s/\(^CONFIG_SND.*\=\).*/\1n/"\
55 55 -e "s/\(^CONFIG_SOUND.*\=\).*/\1n/"\
56 56 -e "s/\(^CONFIG_AC97.*\=\).*/\1n/"\
57 57 -e "s/\(^CONFIG_VIDEO_.*\=\).*/\1n/"\
58 58 -e "s/\(^CONFIG_MEDIA_TUNER.*\=\).*/\1n/"\
59 59 -e "s/\(^CONFIG_DVB.*\=\)[ym]/\1n/"\
60 60 -e "s/\(^CONFIG_REISERFS.*\=\).*/\1n/"\
61 61 -e "s/\(^CONFIG_JFS.*\=\).*/\1n/"\
62 62 -e "s/\(^CONFIG_XFS.*\=\).*/\1n/"\
63 63 -e "s/\(^CONFIG_GFS2.*\=\).*/\1n/"\
64 64 -e "s/\(^CONFIG_OCFS2.*\=\).*/\1n/"\
65 65 -e "s/\(^CONFIG_BTRFS.*\=\).*/\1n/"\
66 66 -e "s/\(^CONFIG_HFS.*\=\).*/\1n/"\
67 67 -e "s/\(^CONFIG_JFFS2.*\=\)[ym]/\1n/"\
68 68 -e "s/\(^CONFIG_UBIFS.*\=\).*/\1n/"\
69 69 -e "s/\(^CONFIG_SQUASHFS.*\=\)[ym]/\1n/"\
70 70 -e "s/\(^CONFIG_W1.*\=\)[ym]/\1n/"\
71 71 -e "s/\(^CONFIG_HAMRADIO.*\=\).*/\1n/"\
72 72 -e "s/\(^CONFIG_CAN.*\=\).*/\1n/"\
73 73 -e "s/\(^CONFIG_IRDA.*\=\).*/\1n/"\
74 74 -e "s/\(^CONFIG_BT_.*\=\).*/\1n/"\
75 75 -e "s/\(^CONFIG_WIMAX.*\=\)[ym]/\1n/"\
76 76 -e "s/\(^CONFIG_6LOWPAN.*\=\).*/\1n/"\
77 77 -e "s/\(^CONFIG_IEEE802154.*\=\).*/\1n/"\
78 78 -e "s/\(^CONFIG_NFC.*\=\).*/\1n/"\
79 79 -e "s/\(^CONFIG_FB_TFT=.*\=\).*/\1n/"\
80 80 -e "s/\(^CONFIG_TOUCHSCREEN.*\=\).*/\1n/"\
81 81 -e "s/\(^CONFIG_USB_GSPCA_.*\=\).*/\1n/"\
82 82 -e "s/\(^CONFIG_DRM.*\=\).*/\1n/"\
83 83 "${KERNEL_DIR}/.config"
84 84 fi
85 85
86 86 if [ "$KERNELSRC_CONFIG" = true ] ; then
87 87 # Load default raspberry kernel configuration
88 88 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" "${KERNEL_DEFCONFIG}"
89 89
90 90 if [ ! -z "$KERNELSRC_USRCONFIG" ] ; then
91 91 cp $KERNELSRC_USRCONFIG ${KERNEL_DIR}/.config
92 92 fi
93 93
94 94 # Start menu-driven kernel configuration (interactive)
95 95 if [ "$KERNEL_MENUCONFIG" = true ] ; then
96 96 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" menuconfig
97 97 fi
98 98 fi
99 99
100 100 # Cross compile kernel and modules
101 101 make -C "${KERNEL_DIR}" -j${KERNEL_THREADS} ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" "${KERNEL_BIN_IMAGE}" modules dtbs
102 102 fi
103 103
104 104 # Check if kernel compilation was successful
105 105 if [ ! -r "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" ] ; then
106 106 echo "error: kernel compilation failed! (kernel image not found)"
107 107 cleanup
108 108 exit 1
109 109 fi
110 110
111 111 # Install kernel modules
112 112 if [ "$ENABLE_REDUCE" = true ] ; then
113 113 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_MOD_STRIP=1 INSTALL_MOD_PATH=../../.. modules_install
114 114 else
115 115 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_MOD_PATH=../../.. modules_install
116 116
117 117 # Install kernel firmware
118 118 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_FW_PATH=../../../lib firmware_install
119 119 fi
120 120
121 121 # Install kernel headers
122 122 if [ "$KERNEL_HEADERS" = true ] && [ "$KERNEL_REDUCE" = false ] ; then
123 123 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_HDR_PATH=../.. headers_install
124 124 fi
125 125
126 126 # Prepare boot (firmware) directory
127 127 mkdir "${BOOT_DIR}"
128 128
129 129 # Get kernel release version
130 130 KERNEL_VERSION=`cat "${KERNEL_DIR}/include/config/kernel.release"`
131 131
132 132 # Copy kernel configuration file to the boot directory
133 133 install_readonly "${KERNEL_DIR}/.config" "${R}/boot/config-${KERNEL_VERSION}"
134 134
135 135 # Copy dts and dtb device tree sources and binaries
136 136 mkdir "${BOOT_DIR}/overlays"
137 137
138 138 # Ensure the proper .dtb is located
139 139 if [ "$KERNEL_ARCH" = "arm" ] ; then
140 140 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/"*.dtb "${BOOT_DIR}/"
141 141 else
142 142 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/broadcom/"*.dtb "${BOOT_DIR}/"
143 143 fi
144 144
145 145 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/"*.dtb* "${BOOT_DIR}/overlays/"
146 146 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/README" "${BOOT_DIR}/overlays/README"
147 147
148 148 if [ "$ENABLE_UBOOT" = false ] ; then
149 149 # Convert and copy kernel image to the boot directory
150 150 "${KERNEL_DIR}/scripts/mkknlimg" "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" "${BOOT_DIR}/${KERNEL_IMAGE}"
151 151 else
152 152 # Copy kernel image to the boot directory
153 153 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" "${BOOT_DIR}/${KERNEL_IMAGE}"
154 154 fi
155 155
156 156 # Remove kernel sources
157 157 if [ "$KERNEL_REMOVESRC" = true ] ; then
158 158 rm -fr "${KERNEL_DIR}"
159 159 else
160 160 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" modules_prepare
161 161
162 162 # Create symlinks for kernel modules
163 163 chroot_exec ln -sf /usr/src/linux "/lib/modules/${KERNEL_VERSION}/build"
164 164 chroot_exec ln -sf /usr/src/linux "/lib/modules/${KERNEL_VERSION}/source"
165 165 fi
166 166
167 167 else # BUILD_KERNEL=false
168 168 # Kernel installation
169 169 chroot_exec apt-get -qq -y --no-install-recommends install linux-image-"${COLLABORA_KERNEL}" raspberrypi-bootloader-nokernel
170 170
171 171 # Install flash-kernel last so it doesn't try (and fail) to detect the platform in the chroot
172 172 chroot_exec apt-get -qq -y install flash-kernel
173 173
174 174 # Check if kernel installation was successful
175 175 VMLINUZ="$(ls -1 ${R}/boot/vmlinuz-* | sort | tail -n 1)"
176 176 if [ -z "$VMLINUZ" ] ; then
177 177 echo "error: kernel installation failed! (/boot/vmlinuz-* not found)"
178 178 cleanup
179 179 exit 1
180 180 fi
181 181 # Copy vmlinuz kernel to the boot directory
182 182 install_readonly "${VMLINUZ}" "${BOOT_DIR}/${KERNEL_IMAGE}"
183 183 fi
@@ -1,653 +1,659
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie" and "stretch" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 10+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 49
50 50 # Debian release
51 51 RELEASE=${RELEASE:=jessie}
52 52 KERNEL_ARCH=${KERNEL_ARCH:=arm}
53 53 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
54 54 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
55 55 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
56 56 if [ "$KERNEL_ARCH" = "arm64" ] ; then
57 57 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
58 58 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
59 59 else
60 60 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
61 61 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
62 62 fi
63 63 if [ "$RELEASE_ARCH" = "arm64" ] ; then
64 64 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
65 65 else
66 66 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
67 67 fi
68 68 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
69 69
70 70 # URLs
71 71 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
72 72 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
73 73 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm80211/brcm}
74 74 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
75 75 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
76 76 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
77 77
78 78 # Build directories
79 79 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
80 80 BUILDDIR="${BASEDIR}/build"
81 81
82 82 # Prepare date string for default image file name
83 83 DATE="$(date +%Y-%m-%d)"
84 84 if [ -z "$KERNEL_BRANCH" ] ; then
85 85 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
86 86 else
87 87 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
88 88 fi
89 89
90 90 # Chroot directories
91 91 R="${BUILDDIR}/chroot"
92 92 ETC_DIR="${R}/etc"
93 93 LIB_DIR="${R}/lib"
94 94 BOOT_DIR="${R}/boot/firmware"
95 95 KERNEL_DIR="${R}/usr/src/linux"
96 96 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
97 97
98 98 # Firmware directory: Blank if download from github
99 99 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
100 100
101 101 # General settings
102 102 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
103 103 PASSWORD=${PASSWORD:=raspberry}
104 104 USER_PASSWORD=${USER_PASSWORD:=raspberry}
105 105 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
106 106 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
107 107 EXPANDROOT=${EXPANDROOT:=true}
108 108
109 109 # Keyboard settings
110 110 XKB_MODEL=${XKB_MODEL:=""}
111 111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 112 XKB_VARIANT=${XKB_VARIANT:=""}
113 113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114 114
115 115 # Network settings (DHCP)
116 116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117 117
118 118 # Network settings (static)
119 119 NET_ADDRESS=${NET_ADDRESS:=""}
120 120 NET_GATEWAY=${NET_GATEWAY:=""}
121 121 NET_DNS_1=${NET_DNS_1:=""}
122 122 NET_DNS_2=${NET_DNS_2:=""}
123 123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 124 NET_NTP_1=${NET_NTP_1:=""}
125 125 NET_NTP_2=${NET_NTP_2:=""}
126 126
127 127 # APT settings
128 128 APT_PROXY=${APT_PROXY:=""}
129 129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 130
131 131 # Feature settings
132 132 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
133 133 ENABLE_I2C=${ENABLE_I2C:=false}
134 134 ENABLE_SPI=${ENABLE_SPI:=false}
135 135 ENABLE_IPV6=${ENABLE_IPV6:=true}
136 136 ENABLE_SSHD=${ENABLE_SSHD:=true}
137 137 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
138 138 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
139 139 ENABLE_SOUND=${ENABLE_SOUND:=true}
140 140 ENABLE_DBUS=${ENABLE_DBUS:=true}
141 141 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
142 142 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
143 143 ENABLE_XORG=${ENABLE_XORG:=false}
144 144 ENABLE_WM=${ENABLE_WM:=""}
145 145 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
146 146 ENABLE_USER=${ENABLE_USER:=true}
147 147 USER_NAME=${USER_NAME:="pi"}
148 148 ENABLE_ROOT=${ENABLE_ROOT:=false}
149 149
150 150 # SSH settings
151 151 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
152 152 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
153 153 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
154 154 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
155 155 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
156 156
157 157 # Advanced settings
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 164 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
165 165 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
166 166 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
167 167 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
168 168 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
169 169 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
170 170
171 171 # Kernel compilation settings
172 172 BUILD_KERNEL=${BUILD_KERNEL:=false}
173 173 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
174 174 KERNEL_THREADS=${KERNEL_THREADS:=1}
175 175 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
176 176 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
177 177 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
178 178 if [ "$KERNEL_ARCH" = "arm64" ] ; then
179 179 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
180 180 else
181 181 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
182 182 fi
183 183
184 184 # Kernel compilation from source directory settings
185 185 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
186 186 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
187 187 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
188 188 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
189 189
190 190 # Reduce disk usage settings
191 191 REDUCE_APT=${REDUCE_APT:=true}
192 192 REDUCE_DOC=${REDUCE_DOC:=true}
193 193 REDUCE_MAN=${REDUCE_MAN:=true}
194 194 REDUCE_VIM=${REDUCE_VIM:=false}
195 195 REDUCE_BASH=${REDUCE_BASH:=false}
196 196 REDUCE_HWDB=${REDUCE_HWDB:=true}
197 197 REDUCE_SSHD=${REDUCE_SSHD:=true}
198 198 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
199 199
200 200 # Encrypted filesystem settings
201 201 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
202 202 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
203 203 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
204 204 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
205 205 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
206 206
207 207 # Stop the Crypto Wars
208 208 DISABLE_FBI=${DISABLE_FBI:=false}
209 209
210 210 # Chroot scripts directory
211 211 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
212 212
213 213 # Packages required in the chroot build environment
214 214 APT_INCLUDES=${APT_INCLUDES:=""}
215 215 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
216 216
217 # Package apt-transport-https has been removed from Debian Buster release
218 # this induces qemu error 383 which does not prevent building an image
219 if [ "$RELEASE" = "buster" ] ; then
220 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/apt-transport-https,//")"
221 fi
222
217 223 # Packages required for bootstrapping
218 224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
219 225 MISSING_PACKAGES=""
220 226
221 227 # Packages installed for c/c++ build environment in chroot (keep empty)
222 228 COMPILER_PACKAGES=""
223 229
224 230 set +x
225 231
226 232 # Set Raspberry Pi model specific configuration
227 233 if [ "$RPI_MODEL" = 2 ] ; then
228 234 DTB_FILE=${RPI2_DTB_FILE}
229 235 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
230 236 elif [ "$RPI_MODEL" = 3 ] ; then
231 237 DTB_FILE=${RPI3_DTB_FILE}
232 238 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
233 239 BUILD_KERNEL=true
234 240 else
235 241 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
236 242 exit 1
237 243 fi
238 244
239 245 # Check if the internal wireless interface is supported by the RPi model
240 246 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
241 247 echo "error: The selected Raspberry Pi model has no internal wireless interface"
242 248 exit 1
243 249 fi
244 250
245 251 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
246 252 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
247 253 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
248 254 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
249 255 exit 1
250 256 fi
251 257 fi
252 258
253 259 # Build RPi2/3 Linux kernel if required by Debian release
254 260 if [ "$RELEASE" = "stretch" ] ; then
255 261 BUILD_KERNEL=true
256 262 fi
257 263
258 264 # Add packages required for kernel cross compilation
259 265 if [ "$BUILD_KERNEL" = true ] ; then
260 266 if [ "$KERNEL_ARCH" = "arm" ] ; then
261 267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
262 268 else
263 269 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
264 270 fi
265 271 fi
266 272
267 273 # Add libncurses5 to enable kernel menuconfig
268 274 if [ "$KERNEL_MENUCONFIG" = true ] ; then
269 275 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
270 276 fi
271 277
272 278 # Stop the Crypto Wars
273 279 if [ "$DISABLE_FBI" = true ] ; then
274 280 ENABLE_CRYPTFS=true
275 281 fi
276 282
277 283 # Add cryptsetup package to enable filesystem encryption
278 284 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
279 285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
280 286 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
281 287
282 288 if [ -z "$CRYPTFS_PASSWORD" ] ; then
283 289 echo "error: no password defined (CRYPTFS_PASSWORD)!"
284 290 exit 1
285 291 fi
286 292 ENABLE_INITRAMFS=true
287 293 fi
288 294
289 295 # Add initramfs generation tools
290 296 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
291 297 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
292 298 fi
293 299
294 300 # Add device-tree-compiler required for building the U-Boot bootloader
295 301 if [ "$ENABLE_UBOOT" = true ] ; then
296 302 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
297 303 fi
298 304
299 305 # Check if root SSH (v2) public key file exists
300 306 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
301 307 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
302 308 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
303 309 exit 1
304 310 fi
305 311 fi
306 312
307 313 # Check if $USER_NAME SSH (v2) public key file exists
308 314 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
309 315 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
310 316 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
311 317 exit 1
312 318 fi
313 319 fi
314 320
315 321 # Check if all required packages are installed on the build system
316 322 for package in $REQUIRED_PACKAGES ; do
317 323 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
318 324 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
319 325 fi
320 326 done
321 327
322 328 # If there are missing packages ask confirmation for install, or exit
323 329 if [ -n "$MISSING_PACKAGES" ] ; then
324 330 echo "the following packages needed by this script are not installed:"
325 331 echo "$MISSING_PACKAGES"
326 332
327 333 echo -n "\ndo you want to install the missing packages right now? [y/n] "
328 334 read confirm
329 335 [ "$confirm" != "y" ] && exit 1
330 336
331 337 # Make sure all missing required packages are installed
332 338 apt-get -qq -y install ${MISSING_PACKAGES}
333 339 fi
334 340
335 341 # Check if ./bootstrap.d directory exists
336 342 if [ ! -d "./bootstrap.d/" ] ; then
337 343 echo "error: './bootstrap.d' required directory not found!"
338 344 exit 1
339 345 fi
340 346
341 347 # Check if ./files directory exists
342 348 if [ ! -d "./files/" ] ; then
343 349 echo "error: './files' required directory not found!"
344 350 exit 1
345 351 fi
346 352
347 353 # Check if specified KERNELSRC_DIR directory exists
348 354 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
349 355 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
350 356 exit 1
351 357 fi
352 358
353 359 # Check if specified UBOOTSRC_DIR directory exists
354 360 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
355 361 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
356 362 exit 1
357 363 fi
358 364
359 365 # Check if specified FBTURBOSRC_DIR directory exists
360 366 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
361 367 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
362 368 exit 1
363 369 fi
364 370
365 371 # Check if specified CHROOT_SCRIPTS directory exists
366 372 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
367 373 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
368 374 exit 1
369 375 fi
370 376
371 377 # Check if specified device mapping already exists (will be used by cryptsetup)
372 378 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
373 379 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
374 380 exit 1
375 381 fi
376 382
377 383 # Don't clobber an old build
378 384 if [ -e "$BUILDDIR" ] ; then
379 385 echo "error: directory ${BUILDDIR} already exists, not proceeding"
380 386 exit 1
381 387 fi
382 388
383 389 # Setup chroot directory
384 390 mkdir -p "${R}"
385 391
386 392 # Check if build directory has enough of free disk space >512MB
387 393 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
388 394 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
389 395 exit 1
390 396 fi
391 397
392 398 set -x
393 399
394 400 # Call "cleanup" function on various signals and errors
395 401 trap cleanup 0 1 2 3 6
396 402
397 403 # Add required packages for the minbase installation
398 404 if [ "$ENABLE_MINBASE" = true ] ; then
399 405 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
400 406 fi
401 407
402 408 # Add required locales packages
403 409 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
404 410 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
405 411 fi
406 412
407 413 # Add parted package, required to get partprobe utility
408 414 if [ "$EXPANDROOT" = true ] ; then
409 415 APT_INCLUDES="${APT_INCLUDES},parted"
410 416 fi
411 417
412 418 # Add dbus package, recommended if using systemd
413 419 if [ "$ENABLE_DBUS" = true ] ; then
414 420 APT_INCLUDES="${APT_INCLUDES},dbus"
415 421 fi
416 422
417 423 # Add iptables IPv4/IPv6 package
418 424 if [ "$ENABLE_IPTABLES" = true ] ; then
419 425 APT_INCLUDES="${APT_INCLUDES},iptables"
420 426 fi
421 427
422 428 # Add openssh server package
423 429 if [ "$ENABLE_SSHD" = true ] ; then
424 430 APT_INCLUDES="${APT_INCLUDES},openssh-server"
425 431 fi
426 432
427 433 # Add alsa-utils package
428 434 if [ "$ENABLE_SOUND" = true ] ; then
429 435 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
430 436 fi
431 437
432 438 # Add rng-tools package
433 439 if [ "$ENABLE_HWRANDOM" = true ] ; then
434 440 APT_INCLUDES="${APT_INCLUDES},rng-tools"
435 441 fi
436 442
437 443 # Add fbturbo video driver
438 444 if [ "$ENABLE_FBTURBO" = true ] ; then
439 445 # Enable xorg package dependencies
440 446 ENABLE_XORG=true
441 447 fi
442 448
443 449 # Add user defined window manager package
444 450 if [ -n "$ENABLE_WM" ] ; then
445 451 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
446 452
447 453 # Enable xorg package dependencies
448 454 ENABLE_XORG=true
449 455 fi
450 456
451 457 # Add xorg package
452 458 if [ "$ENABLE_XORG" = true ] ; then
453 459 APT_INCLUDES="${APT_INCLUDES},xorg"
454 460 fi
455 461
456 462 # Replace selected packages with smaller clones
457 463 if [ "$ENABLE_REDUCE" = true ] ; then
458 464 # Add levee package instead of vim-tiny
459 465 if [ "$REDUCE_VIM" = true ] ; then
460 466 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
461 467 fi
462 468
463 469 # Add dropbear package instead of openssh-server
464 470 if [ "$REDUCE_SSHD" = true ] ; then
465 471 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
466 472 fi
467 473 fi
468 474
469 475 # Configure kernel sources if no KERNELSRC_DIR
470 476 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
471 477 KERNELSRC_CONFIG=true
472 478 fi
473 479
474 480 # Configure reduced kernel
475 481 if [ "$KERNEL_REDUCE" = true ] ; then
476 482 KERNELSRC_CONFIG=false
477 483 fi
478 484
479 485 # Execute bootstrap scripts
480 486 for SCRIPT in bootstrap.d/*.sh; do
481 487 head -n 3 "$SCRIPT"
482 488 . "$SCRIPT"
483 489 done
484 490
485 491 ## Execute custom bootstrap scripts
486 492 if [ -d "custom.d" ] ; then
487 493 for SCRIPT in custom.d/*.sh; do
488 494 . "$SCRIPT"
489 495 done
490 496 fi
491 497
492 498 # Execute custom scripts inside the chroot
493 499 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
494 500 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
495 501 chroot_exec /bin/bash -x <<'EOF'
496 502 for SCRIPT in /chroot_scripts/* ; do
497 503 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
498 504 $SCRIPT
499 505 fi
500 506 done
501 507 EOF
502 508 rm -rf "${R}/chroot_scripts"
503 509 fi
504 510
505 511 # Remove c/c++ build environment from the chroot
506 512 chroot_remove_cc
507 513
508 514 # Remove apt-utils
509 515 if [ "$RELEASE" = "jessie" ] ; then
510 516 chroot_exec apt-get purge -qq -y --force-yes apt-utils
511 517 fi
512 518
513 519 # Generate required machine-id
514 520 MACHINE_ID=$(dbus-uuidgen)
515 521 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
516 522 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
517 523
518 524 # APT Cleanup
519 525 chroot_exec apt-get -y clean
520 526 chroot_exec apt-get -y autoclean
521 527 chroot_exec apt-get -y autoremove
522 528
523 529 # Unmount mounted filesystems
524 530 umount -l "${R}/proc"
525 531 umount -l "${R}/sys"
526 532
527 533 # Clean up directories
528 534 rm -rf "${R}/run/*"
529 535 rm -rf "${R}/tmp/*"
530 536
531 537 # Clean up files
532 538 rm -f "${ETC_DIR}/ssh/ssh_host_*"
533 539 rm -f "${ETC_DIR}/dropbear/dropbear_*"
534 540 rm -f "${ETC_DIR}/apt/sources.list.save"
535 541 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
536 542 rm -f "${ETC_DIR}/*-"
537 543 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
538 544 rm -f "${ETC_DIR}/resolv.conf"
539 545 rm -f "${R}/root/.bash_history"
540 546 rm -f "${R}/var/lib/urandom/random-seed"
541 547 rm -f "${R}/initrd.img"
542 548 rm -f "${R}/vmlinuz"
543 549 rm -f "${R}${QEMU_BINARY}"
544 550
545 551 # Calculate size of the chroot directory in KB
546 552 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
547 553
548 554 # Calculate the amount of needed 512 Byte sectors
549 555 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
550 556 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
551 557 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
552 558
553 559 # The root partition is EXT4
554 560 # This means more space than the actual used space of the chroot is used.
555 561 # As overhead for journaling and reserved blocks 25% are added.
556 562 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
557 563
558 564 # Calculate required image size in 512 Byte sectors
559 565 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
560 566
561 567 # Prepare image file
562 568 if [ "$ENABLE_SPLITFS" = true ] ; then
563 569 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
564 570 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
565 571 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
566 572 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
567 573
568 574 # Write firmware/boot partition tables
569 575 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
570 576 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
571 577 EOM
572 578
573 579 # Write root partition table
574 580 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
575 581 ${TABLE_SECTORS},${ROOT_SECTORS},83
576 582 EOM
577 583
578 584 # Setup temporary loop devices
579 585 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
580 586 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
581 587 else # ENABLE_SPLITFS=false
582 588 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
583 589 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
584 590
585 591 # Write partition table
586 592 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
587 593 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
588 594 ${ROOT_OFFSET},${ROOT_SECTORS},83
589 595 EOM
590 596
591 597 # Setup temporary loop devices
592 598 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
593 599 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
594 600 fi
595 601
596 602 if [ "$ENABLE_CRYPTFS" = true ] ; then
597 603 # Create dummy ext4 fs
598 604 mkfs.ext4 "$ROOT_LOOP"
599 605
600 606 # Setup password keyfile
601 607 touch .password
602 608 chmod 600 .password
603 609 echo -n ${CRYPTFS_PASSWORD} > .password
604 610
605 611 # Initialize encrypted partition
606 612 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
607 613
608 614 # Open encrypted partition and setup mapping
609 615 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
610 616
611 617 # Secure delete password keyfile
612 618 shred -zu .password
613 619
614 620 # Update temporary loop device
615 621 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
616 622
617 623 # Wipe encrypted partition (encryption cipher is used for randomness)
618 624 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
619 625 fi
620 626
621 627 # Build filesystems
622 628 mkfs.vfat "$FRMW_LOOP"
623 629 mkfs.ext4 "$ROOT_LOOP"
624 630
625 631 # Mount the temporary loop devices
626 632 mkdir -p "$BUILDDIR/mount"
627 633 mount "$ROOT_LOOP" "$BUILDDIR/mount"
628 634
629 635 mkdir -p "$BUILDDIR/mount/boot/firmware"
630 636 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
631 637
632 638 # Copy all files from the chroot to the loop device mount point directory
633 639 rsync -a "${R}/" "$BUILDDIR/mount/"
634 640
635 641 # Unmount all temporary loop devices and mount points
636 642 cleanup
637 643
638 644 # Create block map file(s) of image(s)
639 645 if [ "$ENABLE_SPLITFS" = true ] ; then
640 646 # Create block map files for "bmaptool"
641 647 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
642 648 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
643 649
644 650 # Image was successfully created
645 651 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
646 652 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
647 653 else
648 654 # Create block map file for "bmaptool"
649 655 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
650 656
651 657 # Image was successfully created
652 658 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
653 659 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant